# -*- coding: utf-8 -*

import os, json
from Log.Logger import log2File

class ModuleParser:
    def __init__(self, install_dir):
        self.install_dir = install_dir
        self.platform_file = ''


    def get_platform(self):
        platform_file = os.path.join(self.install_dir, 'conf/platform_oem.conf')
        if not os.path.exists(platform_file):
            log2File(platform_file + ' is not exist.')
            return 0
        with open(platform_file, 'r') as f:
            data = json.load(f)
            if data.has_key('platform'):
                self.platform = data['platform']
                return 1
            else:
                log2File(platform_file+': node[platform] is not exit.')
        return 0

    def get_module_list(self):
        module_list = []
        module_file = os.path.join(self.install_dir, 'conf/platform.conf')
        if not os.path.exists(module_file):
            log2File(module_file + ' is not exists.')
            return module_list
        if self.get_platform() == 0:
            return module_list
        else:
            with open(module_file, 'r') as f:
                data = json.load(f)
                if not data.has_key(self.platform):
                    log2File(module_file + ':' + self.platform + 'is not exist.')
                else:
                    module_list = data[self.platform]['module_list']

        return module_list

    def check_module_ver(self):
        return 0
