#-*- coding: utf-8 -*
import os, sys, shutil
import Log
from Log.Logger import log2File
def exitUpdate(code):
    log2File("update status:" + str(code))
    log2File("=============end offline update===========")
    exit(code)
def userVerify():
    if os.geteuid() != 0:
        log2File("This program must be run as root. Aborting.")
        exitUpdate(code)
def pythonVerify():
    major = 2
    minor = 6
    if (sys.version_info[0] < major or (sys.version_info[0] == major and sys.version_info[1]) < minor):
        return False
    return True
if __name__ == "__main__":
    install_dir = ''
    server_install_dir = "/opt/360safe"
    client_install_dir = "/opt/360safeforcnos"
    if os.path.exists(server_install_dir):
        install_dir = server_install_dir
    elif os.path.exists(client_install_dir):
        install_dir = client_install_dir
    else:
        log2File('360safe is not installed')
        exitUpdate(code)
    Log.Logger.install_dir = os.path.join(install_dir, 'Log')
    if not pythonVerify() :
        log2File("Error: python version should later than 2.6!")
        sys.exit(1)
    else:
        import Modules.ModuleMgr
        import FileUtiles.FileMgr
    code = 1
    userVerify()
    if len(sys.argv) != 2:
        print "Usage: python offlineupdate.py update_data_path"
        exit(1)
    
    log2File("=============start offline update===========")
    update_data  = os.path.join(sys.argv[1], 'inst/update')
    if not os.path.exists(update_data):
        log2File(update_data + ' is not exist.')
        exitUpdate(code)
    moduleParser = Modules.ModuleMgr.ModuleParser(install_dir)
    module_list = moduleParser.get_module_list()
    if not module_list:
        log2File("module list is empty.")
        exitUpdate(code)
    tmp_update_dir = os.path.join(install_dir, 'OfflineUpdate/tmpupdate')
    try:
        if os.path.exists(tmp_update_dir):
            shutil.rmtree(tmp_update_dir)
        os.mkdir(tmp_update_dir)
    except IOError, e:
        log2File(tmp_update_dir + ' create fail because ' + e.message)
        exitUpdate(code)

    updatecfg_conf = os.path.join(install_dir, 'updatecfg.ini')
    tmp_updatecfg_conf = os.path.join(tmp_update_dir, 'updatecfg_tmp.ini')
    if os.path.exists(updatecfg_conf):
        shutil.copy(updatecfg_conf, tmp_updatecfg_conf)
    else:
        fd = open(tmp_updatecfg_conf, 'w')
        fd.close()
    module_dat = os.path.join(install_dir, 'Data/asmodularize.dat')
    tmp_module_dat = os.path.join(tmp_update_dir, 'asmodularize_tmp.dat')

    fileMgr = FileUtiles.FileMgr.FileMgr(install_dir, update_data, tmp_update_dir, tmp_updatecfg_conf, tmp_module_dat)

    if os.path.exists(module_dat):
        shutil.copy(module_dat, tmp_module_dat)
    else:
        log2File(module_dat + " is not exists.")
        fileMgr.emptyTmpData()
        exitUpdate(code)
    for module in module_list:
        res = fileMgr.update(module)
        if res == False:
            fileMgr.rollback()
            fileMgr.emptyTmpData()
            exitUpdate(code)

    fileMgr.endUpdate()
    fileMgr.emptyTmpData()
    if fileMgr.reboot and fileMgr.isupdate:
    	code = 100
    else:
	code = 0
    frontend = os.path.join(client_install_dir, "s360safeforcnos")
    if not os.path.exists(frontend):
    	fileMgr.rebootService()
    exitUpdate(code)
	
